明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1997|回复: 4

如何画出已知两个端点和弧长的圆弧

[复制链接]
发表于 2007-8-10 17:19:00 | 显示全部楼层 |阅读模式
如何画出已知两个端点和弧长的圆弧
发表于 2007-8-10 17:24:00 | 显示全部楼层
两个端点和弧长, 不能确定一个弧段吧, 还需要一个条件, 比如包含角度, 或者是弦高之类的
发表于 2007-8-11 23:40:00 | 显示全部楼层

(defun c:aaa (/ p1 p2 s a l x xx fx flx r c c1 c2 mspace myobj)
(defun N ()
(setq c (- (+ a (* 0.5 pi)) (* x 0.5)))
(setq cen (polar p1 c r))
(setq c1 (+ c pi))
(setq c2 (+ c1 x))
(setq myobj (vla-addarc mspace (vlax-3d-point cen) r c1 c2))
(princ)
)
(setq p1 (getpoint "\n请输入圆弧第一点:"))
(setq p2 (getpoint p1 "\n请输入圆弧第二点:"))
(setq s (getdist p1 "\n请输入弧长:"))
(setq a (angle p1 p2))
(setq l (distance p1 p2))
(vl-load-com)
(setq mspace (vla-get-modelspace
(vla-get-activedocument (vlax-get-acad-object))
)
)
(if (<= s l)
(progn
(prompt "您所要画的圆弧并不存在!")
(princ)
)
(progn
(setq x 2)
(setq fx (- (/ (sin (/ x 2)) x) (/ (* 0.5 l) s)))
(setq
flx (/ (- (* 0.5 x (cos (* 0.5 x))) (sin (* 0.5 x))) (* x x))
)
(setq xx (- x (/ fx flx)))
(while (> (abs (- x xx)) 0.0000000001)
(setq x xx)
(setq fx (- (/ (sin (/ x 2)) x) (/ (* 0.5 l) s)))
(setq flx
(/ (- (* 0.5 x (cos (* 0.5 x))) (sin (* 0.5 x))) (* x x))
)
(setq xx (- x (/ fx flx)))
)
(setq r (/ s xx))

(initget "N S")
(setq aa (getkword "\n 请输入圆弧方向[逆时针(N)/顺时针(S)]:"))
(if (= aa nil)
(setq aa "N")
)
(if (= aa "N")
(N)
(if (= aa "S")
(progn
(setq c (- (+ a (/ x 2)) (* 0.5 pi)))
(setq cen (polar p1 c r))
(setq c1 (- (+ c pi) x))
(setq c2 (+ c pi))
(setq myobj (vla-addarc mspace (vlax-3d-point cen) r c1 c2))
(princ)

)
)
)
)
)

发表于 2007-8-14 14:35:00 | 显示全部楼层

条件不够,画不出来

 楼主| 发表于 2007-8-14 15:25:00 | 显示全部楼层

这个lsp在2007绝对没问题,但能不能移植到R14下运用呢

这个lsp在2007绝对没问题,但能不能移植到R14下运用呢
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 21:46 , Processed in 0.176646 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表